'use strict';

var _compact = require('lodash/compact');

var _compact2 = _interopRequireDefault(_compact);

var _forEachRight = require('lodash/forEachRight');

var _forEachRight2 = _interopRequireDefault(_forEachRight);

var _isEmpty = require('lodash/isEmpty');

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _keys = require('lodash/keys');

var _keys2 = _interopRequireDefault(_keys);

var _values = require('lodash/values');

var _values2 = _interopRequireDefault(_values);

var _isObject = require('lodash/isObject');

var _isObject2 = _interopRequireDefault(_isObject);

var _map = require('lodash/map');

var _map2 = _interopRequireDefault(_map);

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var t = _ref.types;

  var addImport = function addImport(node, specifiers, module) {
    return node.body.unshift(t.importDeclaration(specifiers, t.stringLiteral(module)));
  };
  var defaultImport = function defaultImport(binding, scope) {
    return !scope.hasBinding(binding) && t.importDefaultSpecifier(t.identifier(binding));
  };
  var destructuredImport = function destructuredImport(right, left, scope) {
    return !scope.hasBinding(right) && t.importSpecifier(t.identifier(right), t.identifier(left));
  };

  var makeSpecifiers = function makeSpecifiers(bindings, scope) {
    switch (true) {
      case (0, _isArray2.default)(bindings):
        return (0, _map2.default)(bindings, function (binding) {
          return destructuredImport.apply(undefined, _toConsumableArray((0, _isObject2.default)(binding) ? [(0, _values2.default)(binding)[0], (0, _keys2.default)(binding)[0], scope] : [binding, binding, scope]));
        });
      case (0, _isObject2.default)(bindings):
        return [].concat(_toConsumableArray(makeSpecifiers(bindings.default, scope)), _toConsumableArray(makeSpecifiers(bindings.destructured, scope)));
      default:
        return [defaultImport(bindings, scope)];
    }
  };

  return {
    visitor: {
      Program: {
        exit: function exit(_ref2, _ref3) {
          var node = _ref2.node;
          var scope = _ref2.scope;
          var opts = _ref3.opts;

          if ((0, _isEmpty2.default)(opts)) return;
          (0, _forEachRight2.default)(opts, function (bindings, module) {
            var specifiers = (0, _compact2.default)(makeSpecifiers(bindings, scope));
            if (specifiers.length) addImport(node, specifiers, module);
          });
        }
      }
    }
  };
};

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }